program PLAdecoder;
(* (C) 2002, 2003 Jens Schnfeld, www.ami.ga, jens@schoenfeld.de *)
(* compile with Borland Turbo Pascal 5.0 or higher *)
uses crt;


var
    f : file of Byte;
    i,pos : longint;
    b : byte;
    Loram,Hiram,Charen,Exrom,Game,CAS,BA : Boolean;
    ch : char;

(* following comment taken from a different source,      *)
(* and just for clarification on the adapter connections *)

(*     source[0].name:='VA12';
     source[0].value:=1;

     source[1].name:='_cas';
     source[1].value:=2;

     source[2].name:='_loram';
     source[2].value:=4;

     source[3].name:='_hiram';
     source[3].value:=8;

     source[4].name:='_Charen';
     source[4].value:=16;

     source[5].name:='va14';
     source[5].value:=32;

     source[6].name:='a15';
     source[6].value:=64;

     source[7].name:='a14';
     source[7].value:=128;

     source[8].name:='_aec';
     source[8].value:=256;

     source[9].name:='r/_w';
     source[9].value:=512;

     source[10].name:='va13';
     source[10].value:=1024;

     source[11].name:='_exrom';
     source[11].value:=2048;

     source[12].name:='a13';
     source[12].value:=4096;

     source[13].name:='_ba';
     source[13].value:=8192;

     source[14].name:='a12';
     source[14].value:=16384;

     source[15].name:='_game';
     source[15].value:=32768;

     select[0].name:='_roml';
     select[0].value:=1;
     select[1].name:='_i/o';
     select[1].value:=2;
     select[2].name:='col r/w';
     select[2].value:=4;
     select[3].name:='_charom';
     select[3].value:=8;
     select[4].name:='_kernal';
     select[4].value:=16;
     select[5].name:='_basic';
     select[5].value:=32;
     select[6].name:='_casram';
     select[6].value:=64;
     select[7].name:='_romh';
     select[7].value:=128;
  *)

procedure openfile;
begin
     assign (f,'pla.bin'); (* only use the original C64 906114-01 file!*)
     reset (f);
end;

procedure closefile;
begin
     close (f);
end;

procedure printsel(value:byte);
begin
     if (value AND 1)=0 then Begin textcolor(Lightred); write('RomL  '); end;
     if (value AND 2)=0 then Begin textcolor(yellow); write('I/O   '); end;
     if (value AND 8)=0 then Begin textcolor(red);write('Char  '); end;
     if (value AND 16)=0 then Begin textcolor(red);write('kernal'); end;
     if (value AND 32)=0 then Begin textcolor(red);write('basic '); end;
     if (value AND 64)=0 then Begin textcolor(green); write('RAM   '); end;
     if (value AND 128)=0 then Begin textcolor(Lightred);write('RomH  '); end;
     if value=255 then Begin textcolor(white);write('BLANK ');end;
     normvideo;
     if (value AND 4)=0 then Begin write('*'); end else write('.');
end;

procedure writeadr(c:byte);
begin
     NormVideo;
     if c=0  then write ('$0xxx');
     if c=1  then write ('$1xxx');
     if c=2  then write ('$2xxx');
     if c=3  then write ('$3xxx');
     if c=4  then write ('$4xxx');
     if c=5  then write ('$5xxx');
     if c=6  then write ('$6xxx');
     if c=7  then write ('$7xxx');
     if c=8  then write ('$8xxx');
     if c=9  then write ('$9xxx');
     if c=10 then write ('$Axxx');
     if c=11 then write ('$Bxxx');
     if c=12 then write ('$Cxxx');
     if c=13 then write ('$Dxxx');
     if c=14 then write ('$Exxx');
     if c=15 then write ('$Fxxx');
end;

procedure printmap;

(* 3D-accelerated, animated version of this procedure, anyone ;-)? *)

var reg:Byte;
begin

gotoxy(1,1);write('address');
     gotoxy(10,1);write('CPU R');
     gotoxy(20,1);write('CPU W');
     gotoxy(30,1);write('VIC');

     for i:=0 to 15 do
     begin
          gotoxy(1,i+2);
          writeadr(i);
          pos:=0;
          If Loram  then inc(pos,4);
          If Hiram  then inc(pos,8);
          If Charen then inc(pos,16);
          If Exrom  then inc(pos,2048);
          If Game   then inc(pos,32768);
          If CAS    then inc(pos,2);
          If BA     then inc(pos,8192);
          if (i AND 1)=1 then inc(pos,16385); (*VA12, A12*)
          if (i AND 2)=2 then inc(pos,5120); (*VA13, a13*)
          if (i AND 4)=4 then inc(pos,128); (*a14*)
          if (i AND 4)=0 then inc(pos,32); (*VA14, active-low*)
          if (i AND 8)=8 then inc(pos,64); (*a15*)

          (*CPU read*)
          seek (f,(pos+512));
          read (f,b);
          gotoxy(10,i+2);
          printsel(b);

          (*CPU write*)
          seek (f,(pos));
          read (f,b);
          gotoxy(20,i+2);
          printsel(b);

          (*VIC*)
          seek (f,(pos+256+512));
          read (f,b);
          gotoxy(30,i+2);
          printsel(b);
     end;
     writeln;NormVideo;
     if Loram  then writeln('(1) Loram=1')  else writeln('(1) Loram=0');
     if Hiram  then writeln('(2) Hiram=1')  else writeln('(2) Hiram=0');
     if Charen then writeln('(3) Charen=1') else writeln('(3) Charen=0');
     if exrom  then writeln('(4) Exrom=1')  else writeln('(4) Exrom=0');
     if game   then writeln('(5) game=1')   else writeln('(5) game=0');
     if BA     then writeln('(6) BA=1')     else writeln('(6) BA=0');
     if CAS    then writeln('(c) CAS=1')    else writeln('(c) CAS=0');
     write('press 1 to 6 for toggle, c for CAS, q to quit.');
     reg:=0;
     if loram then inc(reg,1);
     if hiram then inc(reg,2);
     if charen then inc(reg,4);
     gotoxy(25,20);write('$0001=$3',reg);
end;


Procedure PrintAbout;
Begin

gotoxy(45,3);write('C64 memory map analyzer');
gotoxy(45,5);write('(C)2002,03 by Jens Schnfeld');
gotoxy(45,6);write('this program is freeware.');
gotoxy(45,7);write('check www.ami.ga');
gotoxy(45,8);write('and www.c64upgra.de');
gotoxy(45,9);write('source on ftp.funt.fi');
gotoxy(45,10);write('mailto: jens@schoenfeld.de');
gotoxy(45,13);write('Colours:');
gotoxy(45,14);textcolor(green);write('memory');
gotoxy(45,15);textcolor(red);write('internal roms');
gotoxy(45,16);textcolor(lightred);write('external roms');
gotoxy(45,17);textcolor(yellow);write('VIC,SID,Colour,CIAs');
gotoxy(45,18);textcolor(white);write('tri-stated bus');
Normvideo;
gotoxy(45,19);write('*=colour ram write');
gotoxy(45,20);write('.=colour ram no write');

End;

Begin
     clrscr;
     Loram:=True;
     Charen:=True;  (* Loram=Hiram=charen=1 is the default state*)
     Hiram:=True;   (* of te 6510 CPU after a reset *)
     Exrom:=True;
     Game:=True;
     CAS:=false;  (* access the memory, this is more like a timing-input *)
                  (* rather than a logic input. Controlled by VIC. *)
     BA:=true;    (* Bus Available, controlled by VIC. *)
     openfile;
     PrintMap;
     PrintAbout;
     repeat
           while not keypressed do;
           ch:=readkey;
           if ch='1' then Loram:=not Loram;
           if ch='2' then Hiram:=not Hiram;
           if ch='3' then Charen:=not Charen;
           if ch='4' then Exrom:=not Exrom;
           if ch='5' then game:=not game;
           if ch='6' then BA:=not BA;
           if ch='c' then CAS:=not CAS;
           printmap;
     until ((ch='q') or (ch='Q'));
     closefile;
end.
